#ifndef _FONT_HPP_
#define _FONT_HPP_


#include"util.hpp"


enum{
  ascii_w =  6,
  ascii_h = 12,

  font_size=200,

  chunk_size = (font_size+(font_size/2)),

};


struct
Chunk
{
  uint8_t  data[chunk_size];

};


struct
ChunkBlock
{
  uint8_t      top;
  uint8_t     left;
  uint8_t    width;
  uint8_t   height;

  Chunk  chunks[chunk_size];

};


void  render(ChunkBlock&  blk, char16_t  c);

bool   open_font(const char*  path);
void  close_font();


void  drawf(uint8_t*  dst, int  pitch, const char*  fmt, ...);


#endif




