#include"screen.hpp"




SDL_Renderer*  renderer;
SDL_Window*      window;


void
change_fullscreen()
{
  const auto  flag = (SDL_GetWindowFlags(window)&SDL_WINDOW_FULLSCREEN);

  SDL_SetWindowFullscreen(window,(flag? 0:SDL_WINDOW_FULLSCREEN));
}


void
screenshot(const char*  path)
{
  auto  bmp = SDL_CreateRGBSurface(0,window_w,window_h,24,0xFF000000,0x00FF0000,0x0000FF00,0);

  SDL_LockSurface(bmp);

  SDL_RenderReadPixels(renderer,nullptr,SDL_PIXELFORMAT_RGBX8888,bmp->pixels,bmp->pitch);

  SDL_UnlockSurface(bmp);

  SDL_SaveBMP(bmp,path);

  SDL_FreeSurface(bmp);
}




