#include"txtlin.hpp"




namespace{


size_t  seek_pos;


SeekState
seek_state;


enum
{
  seek_wait_value = 8,
  seek_act_value  = 4,
};


int  seek_wait_counter;
int  seek_act_counter;
uint32_t  seek_amount;


size_t  seek_amount_max;


}


SeekState
get_seek_state()
{
  return seek_state;
}


int
get_seek_pos()
{
  return seek_pos;
}


void
update_seek_anmount_max()
{
  seek_amount_max = (text::get_length()/4);
}


void
start_seek(SeekState  st)
{
  enum{
    initial_seek_amount = 7
  };


    if(!seek_state)
    {
      seek_state        = st;
      seek_amount       = initial_seek_amount;
      seek_wait_counter = 1;
      seek_act_counter  = seek_act_value;

      seek_pos = get_head_pos();
    }
}


void
finish_seek()
{
  seek_state = SEK_null;
}


void
increase_seek_amount()
{
  seek_amount <<= 2;
  seek_amount  |= 3;

    if(seek_amount >= seek_amount_max)
    {
      seek_amount = seek_amount_max;
    }
}


void
process_seek()
{
  enum{
    seek_counter_value = 6
  };


    switch(seek_state)
    {
      case(SEK_left):
          if(!--seek_wait_counter)
          {
            seek_pos = text::reset_pos(seek_pos-seek_amount);

            seek_wait_counter = seek_wait_value;

              if(!--seek_act_counter)
              {
                increase_seek_amount();

                seek_act_counter = seek_act_value;
              }
          }
        break;
      case(SEK_right):
          if(!--seek_wait_counter)
          {
            seek_pos = text::reset_pos(seek_pos+seek_amount);

            seek_wait_counter = seek_wait_value;

              if(!--seek_act_counter)
              {
                increase_seek_amount();

                seek_act_counter = seek_act_value;
              }
          }
        break;
    }
}




